/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	kerneloutput.h
	Lets the kernel print possibly useful messages.

******************************************************************************/

#ifndef SORTIX_KERNELOUTPUT_H
#define SORTIX_KERNELOUTPUT_H

class KernelOutput : public IPrintable
{
private:
	// DEBUG: Please remove
	int Constructed;

private:
	clrchar Text[80*25];
	VidMemTextScreen Screen;
	size_t Width;
	size_t Height;
	size_t Pos;
	clrchar Color;

public:
	KernelOutput();

private:
	void Newline();

public:
	size_t GetWidth() { return Width; }
	size_t GetHeight() { return Height; }

public:
	clrchar SetColor(clrchar NewColor);
	virtual void Print(const char* String);
	void Debug(const char* String);
	void Error(const char* String);
	void Log(const char* String);
	void Warning(const char* String);
	void Flush();

};

#endif

