/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	panic.cpp
	Displays an error whenever something critical happens.

******************************************************************************/

#include "types.h"
#include "itextscreen.h"
#include "vidmemtextscreen.h"
#include "iprintable.h"
#include "kerneloutput.h"
#include "panic.h"

extern "C" void Panic(const char* Error)
{
	KernelOutput Out;

	Out.SetColor(COLOR8_RED);
	Out.Print("                                                       _                       ");
	Out.Print("                                                      / \\                      ");
	Out.Print("                  /\\    /\\                           /   \\                     ");
	Out.Print("                 /  \\  /  \\                          |   |                     ");
	Out.Print("                /    \\/    \\                         |   |                     ");
	Out.Print("               |  X    X    \\_______________________ /   |                     ");
	Out.Print("               |                                         |                     ");
	Out.Print("               | _________                               /                     ");
	Out.Print("                \\                                       /                      ");
	Out.Print("                  ------       ---------------      ---/                       ");
	Out.Print("                       /       \\             /      \\                          ");
	Out.Print("                      /         \\           /        \\                         ");
	Out.Print("                     /           \\         /          \\                        ");
	Out.Print("                    /_____________\\       /____________\\                       ");
	Out.Print("                                                                               ");
	Out.Print("                                                                               ");
	Out.SetColor((COLOR8_DARK_GREY << 4) + COLOR8_RED);
	Out.Print("                              RED MAXSI OF DEATH                               ");
	Out.SetColor(COLOR8_RED);
	Out.Print("                                                                               ");
	Out.Print(Error);
	Out.Flush();

	HaltKernel();
}
