#include "types.h"

// Implements required C++ stuff for use in the Sortix kernel.

extern "C" void __cxa_pure_virtual()
{
	// This shouldn't happen. Possibly crash the kernel here.
}

#ifdef PLATFORM_X86
// Divides two 64-bit integers in O(logN). I think.
extern "C" uint64_t __udivdi3(uint64_t A, uint64_t B)
{
	uint64_t ACC = 0;
	uint64_t R = 0;
	uint64_t PWR = 1;
	uint64_t EXP = B;

	while ( EXP <= A - ACC )
	{
		R += PWR;
		ACC += EXP;
		
		if ( 2 * EXP <= A - ACC )
		{
			PWR++;
			EXP *= 2;
		}
		else if ( A - ACC < B )
		{
			break;
		}
		else
		{
			while ( A - ACC < EXP )
			{
				PWR--;
				EXP /= 2;
			}
		}
	}

	return R;
}

// Mods two 64-bit integers in O(logN). I think.
extern "C" uint64_t __umoddi3(uint64_t A, uint64_t B)
{
	uint64_t ACC = 0;
	uint64_t R = 0;
	uint64_t PWR = 1;
	uint64_t EXP = B;

	while ( EXP <= A - ACC )
	{
		R += PWR;
		ACC += EXP;
		
		if ( 2 * EXP <= A - ACC )
		{
			PWR++;
			EXP *= 2;
		}
		else if ( A - ACC < B )
		{
			break;
		}
		else
		{
			while ( A - ACC < EXP )
			{
				PWR--;
				EXP /= 2;
			}
		}
	}

	return A - ACC;
}
#endif

