/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	idt-asm.s
	Sets up the Interrupt Descriptor Table.

******************************************************************************/

.section .text

.globl DisableInterrupts
.type DisableInterrupts, @function # void EnableInterrupts()
DisableInterrupts:
	cli
	ret

.globl EnableInterrupts
.type EnableInterrupts, @function # void EnableInterrupts()
EnableInterrupts:
	sti
#Loop:
#	movl %eax, %ecx
#	movl %ebx, %eax
#	movl %ecx, %eax
#	jmp Loop
	ret

.globl IDT__Flush
.type IDT__Flush, @function # void IDT__Flush(void* IDT)
IDT__Flush:
	movl 4(%esp), %eax
	lidt (%eax)
	ret

# Uninitialized Handler
.globl IDT__Uninitialized
.type IDT__Uninitialized, @function
IDT__Uninitialized:
	cli
	pushl $0
	pushl $255

	pusha

	push %ds
	push %es
	push %fs
	push %gs

	mov $0x10, %ax # Load the kernel data segment descriptor.
	mov %ax, %ds
	mov %ax, %es
	mov %ax, %fs
	mov %ax, %gs

	call IDT__FaultHandler

	pop %eax # Reload the original data segment descriptor.
	pop %gs
	pop %fs
	pop %es
	pop %ds

	popa
	add $8, %esp # Cleans up the pushed error code and pushed ISR number
	sti
	iret # pops 5 things at once: CS, EIP, EFLAGS, SS, and ESP.

