/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	irq-asm.s
	Sets up and handles the Interrupt Requests.

******************************************************************************/

.globl IRQ__IRQ0
.globl IRQ__IRQ1
.globl IRQ__IRQ2
.globl IRQ__IRQ3
.globl IRQ__IRQ4
.globl IRQ__IRQ5
.globl IRQ__IRQ6
.globl IRQ__IRQ7
.globl IRQ__IRQ8
.globl IRQ__IRQ9
.globl IRQ__IRQ10
.globl IRQ__IRQ11
.globl IRQ__IRQ12
.globl IRQ__IRQ13
.globl IRQ__IRQ14
.globl IRQ__IRQ15
.globl IRQ__IRQ16
.globl IRQ__IRQ17
.globl IRQ__IRQ18
.globl IRQ__IRQ19
.globl IRQ__IRQ20
.globl IRQ__IRQ21
.globl IRQ__IRQ22
.globl IRQ__IRQ23
.globl IRQ__IRQ24
.globl IRQ__IRQ25
.globl IRQ__IRQ26
.globl IRQ__IRQ27
.globl IRQ__IRQ28
.globl IRQ__IRQ29
.globl IRQ__IRQ30
.globl IRQ__IRQ31
.section .text

# Writes a byte to a specific output port.
.globl WriteByteToPort
.type WriteByteToPort, @function # void WriteByteToPort(int port, int byte)
WriteByteToPort:
	movzbl 0x8(%esp),%eax
	movzwl 0x4(%esp),%edx
	out    %al,(%dx)
	ret

.type IRQ__IRQ0, @function
IRQ__IRQ0:
	cli
	pushl $0
	pushl $32
	jmp IRQ__CommonStub

.type IRQ__IRQ1, @function
IRQ__IRQ1:
	cli
	pushl $0
	pushl $33
	jmp IRQ__CommonStub

.type IRQ__IRQ2, @function
IRQ__IRQ2:
	cli
	pushl $0
	pushl $34
	jmp IRQ__CommonStub

.type IRQ__IRQ3, @function
IRQ__IRQ3:
	cli
	pushl $0
	pushl $35
	jmp IRQ__CommonStub

.type IRQ__IRQ4, @function
IRQ__IRQ4:
	cli
	pushl $0
	pushl $36
	jmp IRQ__CommonStub

.type IRQ__IRQ5, @function
IRQ__IRQ5:
	cli
	pushl $0
	pushl $37
	jmp IRQ__CommonStub

.type IRQ__IRQ6, @function
IRQ__IRQ6:
	cli
	pushl $0
	pushl $38
	jmp IRQ__CommonStub

.type IRQ__IRQ7, @function
IRQ__IRQ7:
	cli
	pushl $0
	pushl $39
	jmp IRQ__CommonStub

.type IRQ__IRQ8, @function
IRQ__IRQ8:
	cli
	pushl $0
	pushl $40
	jmp IRQ__CommonStub

.type IRQ__IRQ9, @function
IRQ__IRQ9:
	cli
	pushl $0
	pushl $41
	jmp IRQ__CommonStub

.type IRQ__IRQ10, @function
IRQ__IRQ10:
	cli
	pushl $0
	pushl $42
	jmp IRQ__CommonStub

.type IRQ__IRQ11, @function
IRQ__IRQ11:
	cli
	pushl $0
	pushl $43
	jmp IRQ__CommonStub

.type IRQ__IRQ12, @function
IRQ__IRQ12:
	cli
	pushl $0
	pushl $44
	jmp IRQ__CommonStub

.type IRQ__IRQ13, @function
IRQ__IRQ13:
	cli
	pushl $0
	pushl $45
	jmp IRQ__CommonStub

.type IRQ__IRQ14, @function
IRQ__IRQ14:
	cli
	pushl $0
	pushl $46
	jmp IRQ__CommonStub

.type IRQ__IRQ15, @function
IRQ__IRQ15:
	cli
	pushl $0
	pushl $47
	#jmp IRQ__CommonStub # Redundant.

.type IRQ__CommonStub, @function
IRQ__CommonStub:

	pusha

	push %ds
	push %es
	push %fs
	push %gs

	mov $0x10, %ax # Load the kernel data segment descriptor.
	mov %ax, %ds
	mov %ax, %es
	mov %ax, %fs
	mov %ax, %gs

	call IRQ__Handle

	pop %eax # Reload the original data segment descriptor.
	pop %gs
	pop %fs
	pop %es
	pop %ds

	popa
	add $8, %esp # Cleans up the pushed error code and pushed IRQ number
	sti
	iret # pops 5 things at once: CS, EIP, EFLAGS, SS, and ESP.

