/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	isr.h
	Sets up and handles the Interrupt Service Routines.

******************************************************************************/

#ifndef SORTIX_ISR_H
#define SORTIX_ISR_H

// This defines what the stack looks like after an ISR was running
struct ISR__Regs
{
    unsigned int gs, fs, es, ds; // Pushed the segs last
    unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax; // Pushed by 'pusha'.
    unsigned int InterruptNumber, ErrorCode; // our 'Push byte #' and ecodes do this.
    unsigned int eip, cs, eflags, useresp, ss; // Pushed by the processor automatically.
};	

class ISR
{	
public:
	void Init();

};

#endif

