/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	paging.s
	A few assembly functions useful for setting up paging.

******************************************************************************/

.globl Paging__Enable
.globl Paging__Disable
.section .text

.type Paging__Enable, @function # void Paging__Enable(size_t* PageDirectoryPhysicalAddress)
Paging__Enable:
	mov 4(%esp), %cr3
	mov %cr0, %eax
	or %eax, 0x80000000
	mov %eax, %cr0
	ret

.type Paging__Disable, @function # void Paging__Disable()
Paging__Disable:
	mov %cr0, %eax
	and %eax, 0x7FFFFFFF
	mov %eax, %cr0
	ret

