/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	vidmemtextscreen.h
	Writes directly to the 80x25 video memory and displays colorable text.

******************************************************************************/

#ifndef SORTIX_VIDMEMTEXTSCREEN_H
#define SORTIX_VTDMEMTEXTSCREEN_H

class VidMemTextScreen : public ITextScreen
{
private:
	size_t Width;
	size_t Height;
	size_t Pos;
	clrchar Color;	

public:
	VidMemTextScreen();

public:
	virtual Format GetFormat();
	virtual size_t GetWidth();
	virtual size_t GetHeight();
	virtual void Seek(size_t X, size_t Y);
	virtual void WriteRaw(const void* Data, size_t DataSize);
	virtual bool Write(Format F, const void* Data, size_t DataSize);

};

#endif

